.nolist
.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.xmm
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
;uselib msimg32
;uselib shell32
;uselib comdlg32
;uselib masm32
;uselib debug

inv equ Invoke

ifndef DoLocal
    DoLocal=0
endif
if DoLocal
    include Printx.inc
else
    include \WinAsm\Progs\AllMyStuff\Printx.inc
endif

MaxTests equ 999 ; maximum number of timing tests

soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

msg Macro qtext:VARARG
local result
pusha
    quote SUBSTR <qtext>,1,1
    IFIDN quote , <">  ;; if this is a quoted string
        invoke MessageBox,hWin,soff(qtext),0,0
    else
        result=opattr(qtext)
        if result eq 48 ;; a register
            invoke MessageBox,hWin,qtext,0,0
        else
            invoke MessageBox,hWin,addr qtext,0,0
        endif
    endif   
popa
endm

Desc Macro TextVal:Req  ; used in the first line of each test proc (Test1....Testxx)
local DescLoc, FirstFlag
.data
DescLoc db TextVal
FirstFlag db 0  ;; separate first flag for every test
.code
    .if FirstFlag==0    ; if not first time, just continue
        mov ebx,offset DescLoc
        call SetDesc
        mov FirstFlag,1 ; set done for next time
        ret     ; if this was the first time, just return without running rest of code
    .endif
endm

Showit Macro longint:req
    pusha
    mov eax,TestNum
    add eax,6000
    inv SetDlgItemInt,hWin2,eax,longint,0
    popa
endm

.data?
align 4
hInst         dd ?
hWin          dd ? ; dialog handle
hWin2         dd ? ; dialog2 handle
hEdit         dd ?
StartingCycle dd ?
CyclePart2    dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
sample        dd ?
curr          dd ?
Result        dd ?
CurAnsHandle  dd ?
mean1         dd ?
mean2         dd ?
plotf         dd ?
statsbuffer   dd 2000 dup (?)  ; value,count
nextfreestat  dd ?
average       dd ?
mean          dd ?
median        dd ?
points        dd ?
TimeTestbuff  db 1000 dup (?)
.data
align 4
Overhead      dd 0   ; overhead of doing an empty proc
Overheadflg   dd 0
MaxX          dd 0  ; screen size
MaxY          dd 0
abuff         dd offset TimeTestbuff
ifndef crlf
  crlf db 13,10,0,0
endif
ProgName      db 'Timing Test',0
.code

ExtraLoopSize = 10  ; number of times to warm up the cache before testing
BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    pusha

if saveplot
    call SetupSavePlot
endif

if tsttype eq DoAvg     ;; old style
    
	mov Loops,TimesToLoop
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ;; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    xor eax,eax
	align 16	; just to be sure all code starts with equal advantage
	nop        ; adjust so actual test code starts on 16 byte boundary
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
TimingLoop = $

else    ;; DoMin, DoSep, DoMode

    call SetupTests
ExtraLoopsLoop = $
    sub ExtraLoops,1
TimingLoop = $
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
     xor eax,eax
     cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    rdtsc
    mov [StartingCycle],eax
    mov [StartingCycle+4],edx

endif
endm

EndCounter macro        ; This macro is inserted after each block of test code

if tsttype eq DoAvg  ;; oldstyle

    sub Loops,1
    jnz TimingLoop
    xor eax,eax
    cpuid       ; flush
    rdtsc
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	mov ecx,TimesToLoop		; divide by number of times through the loop
	div ecx				; result of division in EAX, remainder in EDX
    sub eax,Overhead
    .if sdword ptr eax<0
        mov eax,0
    .endif        
    mov Result,eax

else

    xor eax,eax
    cpuid       ; flush
    rdtsc
    cmp ExtraLoops,0
    jne ExtraLoopsLoop  ; skip first several iterations to warm up the cache
    call WrapupTests
    sub Loops,1
    jnz TimingLoop

endif

if tsttype eq DoMin

    mov eax,Min
    mov Result,eax
        
elseif tsttype eq DoSep

    mov eax,mean1
    mov edx,mean2
    mov ecx,TimesToLoop
    div ecx
    mov Result,eax

endif

if tsttype ne DoAvg
    call FinalWrap
endif

    if saveplot
        inv CloseHandle,plotf
    endif
             
    popa
endm

SetupTests proc
    mov Min,-1 ;9999999999
    mov sample,1
    mov mean1,0
    mov mean2,0
    mov Loops,TimesToLoop
    .if Loops > 1000
       msg "maximum times to loop is 1000.  There is no reason to do more, and much less is just as good."
       mov Loops,1000
    .endif
    mov ExtraLoops,ExtraLoopSize  ; will do several times first to let things settle out
    mov nextfreestat,offset statsbuffer
	ret
SetupTests endp

WrapupTests proc
    sub eax,[StartingCycle] ; get result in EDX:EAX
    sbb edx,[StartingCycle+4]

    sub eax,Overhead
    .if sign?
        xor eax,eax
    .endif
    cmp Min,eax
    jb @f
    mov Min,eax
@@:
    mov curr,eax
    add mean1,eax   ; keep running average
    adc mean2,edx
    mov ebx,offset statsbuffer
    .repeat ; curr in eax
        .if ebx==nextfreestat  ; new one, store it
            mov [ebx],eax   ; curr
            mov dword ptr [ebx+4],1
            add nextfreestat,8
            .break
        .elseif eax==[ebx]
            add dword ptr [ebx+4],1
            .break
        .elseif eax<[ebx] ; move all point up and insert new point
            mov edi,nextfreestat
            add edi,4
            mov esi,edi
            sub esi,8
            add nextfreestat,8
            mov ecx,edi
            sub ecx,ebx ; number of bytes to move
            shr ecx,2
            std
            rep movsd            
            cld
            mov [ebx],eax
            mov dword ptr [ebx+4],1
            .break
        .endif
        add ebx,8
    .until 0
    if saveplot
        printx abuff
        printxa dd sample," ",dd curr,crlf
        inv _lwrite,plotf,abuff,printxsize
    endif    
    inc sample    
    mov ExtraLoops,ExtraLoopSize   ; will do several times first to let things settle out
	ret
WrapupTests endp
FinalWrap proc
    local hstats,mid,tmp
    mov mid,TimesToLoop/2
    mov esi,offset statsbuffer
    mov edi,0
    mov eax,mid
    .repeat
        add edi,[esi+4]
        .if edi >= mid
            mov eax,[esi]
            mov median,eax
            .break
        .endif
        add esi,8
    .until esi>=nextfreestat
    inv _lcreat,soff("Stats.txt"),0
    mov hstats,eax
    mov esi,offset statsbuffer
    mov tmp,0
    .repeat
        printx abuff
        mov eax,[esi+4]
        add tmp,eax
        printxa dd [esi]," ",dd [esi+4]," ",dd tmp,crlf
        inv _lwrite,hstats,abuff,printxsize
        add esi,8
    .until esi>=nextfreestat
    inv CloseHandle,hstats   
	ret
FinalWrap endp
SetupSavePlot proc
    inv _lcreat,soff("Plot.txt"),0
    mov plotf,eax
	ret
SetupSavePlot endp

;------------------------------------------------------------------------------------------
; ----------------- miscellaneous procs for setting up the timing test --------------------
;------------------------------------------------------------------------------------------
.nolist
.data?
align 4
CallTable dd MaxTests dup (?)       ; up to MaxTests tests allowed
TableEnd equ $
bhead        dd ? ; bottom header handle
srect RECT <>     ; scratch
w2pos RECT <>     ; subwin position

Sizesubwin  dd ? ; total vertical pixels needed from subwin
Widthsubwin dd ?
LineSize    dd ? ; size of one line step (one control or whatever).  Set in dialog proc of subwin.
nPosMax     dd ? ; maximum pixel to scroll up to on subwin using page or line movement

CurProcess  dd ?
TestNum     dd ?
htemp       dd ?
;Loops      dd ?
hFnt        dd ?
headersize  dd ?
headers     db 256 dup (?)

vs        SCROLLINFO <>
;SCROLLINFO STRUCT
;  cbSize        DWORD sizeof scrollinfo
;  fMask         DWORD SIF_ALL for page, pos, and range
;  nMin          DWORD minimum scrolling postion
;  nMax          DWORD maximum scrolling postion
;  nPage         DWORD page size (sizes scroll box)
;  nPos          DWORD position of scroll box
;  nTrackPos     DWORD doesn't seem to work for anything
;SCROLLINFO ENDS

LastControl dd ?    ; ID of bottom most control on subwin. Set in MakeControls.
                    ; Used for computing bottommost pixel on subwin to show.
.code

RunTest proc
    pusha
    inv Sleep,100
    inv UpdateWindow,hWin2
    invoke GetCurrentProcess
    mov [CurProcess],eax
    invoke SetPriorityClass, CurProcess, REALTIME_PRIORITY_CLASS
    invoke SetProcessPriorityBoost, CurProcess, FALSE   ; normal behavior
    invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_TIME_CRITICAL
    mov eax,TestNum
    mov eax,[CallTable+eax*4-4]
    .if eax
        call eax    ; call Test1 or Test2 or .... TestN
    .endif
    invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_NORMAL
    invoke SetPriorityClass, CurProcess, NORMAL_PRIORITY_CLASS
    .if Overheadflg
        mov eax,TestNum
        add eax,5000        ; Result cycles
        inv SetDlgItemInt,hWin2,eax,Result,TRUE
        if (tsttype eq DoMin) or (tsttype eq DoSep)
            Showit Min
        endif               
    .endif    
    .if PrintResults
        call PrintToFile
    .endif
    inv UpdateWindow,hWin2
    popa
	ret
RunTest endp

GetCpuInfo proc uses esi edi ebx    ; modified from code by JJ2007
    local IsAmd,CpuSSE,CpuFamily,CpuModel,CpuStep,CpuBrand[12]
    xor eax, eax
    db 0Fh, 0A2h                ; cpuid 0
    .if eax==0
        printxa "CPUID not supported",13,10
        jmp GetCpuInfoRet
    .endif
    mov IsAmd,0
    .if ecx=="DMAc"
        inc IsAmd           ; +1=yes, it's an AMD
    .endif

    push 1
    pop eax
    db 0Fh, 0A2h                ; cpuid 1
    mov ebx, eax
    and eax, 15
    mov CpuStep, eax
    
    shr ebx, 4
    mov eax, ebx
    and eax, 15
    mov CpuModel, eax
    
    shr ebx, 4
    mov eax, ebx
    and eax, 15
    mov CpuFamily, eax
    xor eax, eax
    bt edx, 25              ; edx bit 25, SSE1
    adc eax, 0
    bt edx, 26              ; edx bit 26, SSE2
    adc eax, 0
    bt ecx, 0               ; ecx bit 0, SSE3
    adc eax, 0
    bt ecx, 9               ; ecx bit 9, SSE4
    adc eax, 0
    mov CpuSSE, eax
    .if IsAmd
        mov eax,80000001h
        CpuId
        shr eax,8
        and eax,0fh
        mov CpuFamily,eax 
    .endif
    mov esi, 80000002h
    lea edi,CpuBrand
    .Repeat
        mov eax, esi
        db 0Fh, 0A2h            ; cpuid 80000002h-80000004h
        stosd
        mov eax, ebx
        stosd
        mov eax, ecx
        stosd
        mov eax, edx
        stosd
        inc esi
    .Until esi==80000005h
    printxa addr CpuBrand,32,40,"Family ",dd CpuFamily," Model ",dd CpuModel," Step ",dd CpuStep,41," SSE",dd CpuSSE,13,10
GetCpuInfoRet:
    ret
GetCpuInfo endp

.data
Wide1 = 50      ; width of Test Button
Wide2 = 212     ; width of Description
Wide3 = 75      ; width of Clock Cycles
Wide4 = 75      ; width of Average Clocks
Wide5 = 75      ; width of scratch
Left1 = 15      ; Button   2001, 2002, .... , 2020   
Left2 = Left1+Wide1+4 ; Edit 1, Description, will compute location, 3001, 3002, ... , 3020
Left3 = Left2+Wide2+2 ; Edit 2, Clock Cycles, 4001, ...
Left4 = Left3+Wide3+2 ; Edit 3, Average Clocks 5001, ...
Left5 = Left4+Wide4+2 ; Edit 4, Test routine scratch for output value if desired, 6001, ...
TDel  = 32      ; Height of rows
HDel  = 16      ; Height of header rows
ifndef TopLine
    TopLine = 0
endif
Top     dd TopLine     ; top of all, will increment by TDel
Edge    dd Left5 + Wide5
blank   db ' ',0
aBlank  dd offset blank
edt     db 'EDIT',0,0
CtlGp   dd  2000    ; base id
.code 

DlgProc proc uses ebx edi hWnd,uMsg,wParam,lParam
   local NewHeight:dword,NewWidth:dword
   .if uMsg == WM_COMMAND
        .if wParam==1101    ; run all tests
            mov TestNum,1
            mov ebx,offset CallTable
            .repeat
                .if dword ptr [ebx]   ; was there an address set up?
                    call RunTest
                .endif
                add ebx,4
                add TestNum,1
            .until TestNum>MaxTests
        .endif
        
    .elseif uMsg== WM_INITDIALOG
        pusha
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        inv SendMessage,hWin,WM_GETFONT,0,0 ; get the font for the controls to use
        mov hFnt,eax
        inv SystemParametersInfo,SPI_GETWORKAREA,0,addr srect,0
        m2m MaxX,srect.right
        m2m MaxY,srect.bottom
        lea edi,CallTable
        mov ecx,TableEnd-CallTable
        xor eax,eax
        rep stosb
        BeginCounter
          ; null test to get overhead
        EndCounter
        mov eax,Result
        mov Overhead,eax
        mov Overheadflg,1
        mov edx,Overhead
        call MakeHeaders
        m2m w2pos.top,Top   ; always start subwin window here, just below header

        printx offset headers
        call GetCpuInfo
        if tsttype eq DoMin
            printxa crlf,"Method: Min",crlf
        elseif tsttype eq DoAvg
            printxa crlf,"Method: Average",crlf
        endif
        printxa "Iterations: ",dd TimesToLoop,crlf
        printxa '        Clocks   Description',crlf
        push printxsize
        pop headersize
        printx abuff,"Iterations: ",dd TimesToLoop,"   Overhead: ",dd Overhead,"   Option: "
        if tsttype eq DoMin
            printxa "Minimum"
        elseif tsttype eq DoAvg
            printxa "Average"
        elseif tsttype eq DoSep
            printxa "Separated Average"
        else
            printxa "Unknown"
        endif
        inv SetDlgItemText,hWin,1001,abuff
        mov edx,offset DlgProc2
        inv CreateDialogParam,hInst, 102, hWin, edx, 0

        inv GetWindowRect,hWin,addr srect
        m2m srect.right,Edge
        add srect.right,22
        mov eax,Sizesubwin
        add eax,w2pos.top     ; as set right after MakeHeaders above
        add eax,TDel
        .if eax>MaxY
          mov eax,MaxY
        .endif
        mov srect.bottom,eax      ;new height
        inv MoveWindow,hWin,srect.left,0,srect.right,srect.bottom,TRUE   
        popa
    .elseif uMsg == WM_SIZE
        .if hWin2  ; if subwin dialog is defined
            mov eax,lParam
            mov NewWidth,eax
            and NewWidth,0ffffh ; the new width
            shr eax,16          ; the new height
            mov NewHeight,eax
            mov eax,NewWidth
            sub eax,14
            .if eax > Edge
                mov eax,Edge
            .endif
            add eax,14
            mov w2pos.right,eax
            ; fit subwin into parent window
            mov eax,NewHeight
            sub eax,w2pos.top
            sub eax,4
            mov w2pos.bottom,eax
            mov vs.nPage,eax        ; save size of one page
            inv MoveWindow,hWin2,w2pos.left,w2pos.top,w2pos.right,w2pos.bottom,TRUE
        .endif  
    .elseif uMsg == WM_CLOSE
        invoke  EndDialog,hWin,0
    .endif
    xor eax,eax
    ret
DlgProc endp

DlgProc2 proc uses edx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
Local yAmount:DWORD
    .if uMsg == WM_COMMAND
        .if wParam > 2000 && wParam < 3000 ; one of the test buttons
            mov eax,wParam
            sub eax,2000
            mov TestNum,eax ; save the actual test number, 1..999
            call RunTest
        .endif
    .elseif uMsg==WM_SIZE       ; we were resized by hWin, fix scroll bar limits
        mov eax,Sizesubwin      ; compute scroll bar upper limit from total pixels needed
        sub eax,w2pos.bottom    ; Size of subwin - visible height of subwin + 1
        add eax,1
        mov nPosMax,eax         ; maximum top pixel to show of subwin when moving by one line or page
        inv SetScrollInfo,hWin2,SB_VERT,addr vs,TRUE
        mov eax,vs.nPos         ; check to see if scroll needs adjustment
        .if eax > nPosMax       ; subwin is scrolled up too much
            .if eax > vs.nMin   ; otherwise, already scrolled down as much as possible
                sub eax,nPosMax
                sub vs.nPos,eax
                inv ScrollWindow,hWin2,0,eax,0,0
            .endif
        .endif
    .elseif uMsg==WM_VSCROLL
        mov edx,wParam
        and edx,0ffffh      ; save scroll bar movement code in edx
        mov eax,vs.nPage    ; assume it's a page movement
        .if edx==SB_LINEUP || edx==SB_LINEDOWN
            mov eax,LineSize    ; nope, its move one line
        .endif
        mov yAmount,eax         ; save movement amount for page or line
        .if edx==SB_LINEDOWN    || edx==SB_PAGEDOWN  ; actually need to scroll screen up
            mov eax,nPosMax ; is there enough room left to move amount wanted
            sub eax,vs.nPos
            .if eax < yAmount   
                mov yAmount,eax ; no, just use amount available
            .endif
            neg yAmount     ; scroll negative (up) to bring next line into view
        .elseif edx==SB_LINEUP || edx==SB_PAGEUP
            mov eax,vs.nPos
            sub eax,vs.nMin ; is there enough room left to move amount wanted
            .if eax < yAmount   
                mov yAmount,eax ; no, just use amount available
            .endif
        .elseif edx==SB_THUMBTRACK  ; || dx==SB_THUMBPOSITION
            mov eax,wParam
            shr eax,16      ; new position of scroll box
            neg eax
            add eax,vs.nPos ; where the scroll box was
            mov yAmount,eax ; amount of move
        .else
            jmp NoScroll    ; unknown or unwanted, e.g. SB_ENDSCROLL or SB_THUMBPOSITION, don't move
        .endif
        mov eax,yAmount ; amount of move
        sub vs.nPos,eax
        inv ScrollWindow,hWin2,0,eax,NULL,NULL
        inv SetScrollInfo,hWin2,SB_VERT,addr vs,TRUE
        inv UpdateWindow,hWin2
        NoScroll:
    .elseif uMsg== WM_INITDIALOG    ; set up sizes based upon controls in subwin dialog
        push hWnd
        pop  hWin2
        testnum=0
        mov Top,0
        call CallTableSetup ; go set up the address for the procs to test, add controls, etc.
        mov vs.cbSize,sizeof SCROLLINFO
        mov vs.fMask,SIF_ALL
        mov vs.nMin,0
        mov vs.nPos,0
        mov vs.nPage,20      ; this will be recomputed properly later
        ; get bottom pixel of subwin to show.  Will use bottommost control here but
        ; could use height of subwin if subwin is well formatted.
        inv GetDlgItem,hWin2,LastControl   ; last control on subwin
        inv GetWindowRect,eax,addr srect
        inv MapWindowPoints, NULL, hWin2, addr srect, 2
        mov eax,srect.bottom    ; last pixel needed
        mov Sizesubwin,eax   ; max needed (last pixel used on subwin)
        mov vs.nMax,eax     ; will reset later after size of subwin is known
        
        ; now compute size of one line (one click on up or down arrow) (or just hardcode as desired)
        push srect.bottom   ; save bottom of control above last control
        mov eax,LastControl
        dec eax
        inv GetDlgItem,hWin2,eax   ; get step of one control + spacing height
        inv GetWindowRect,eax,addr srect
        inv MapWindowPoints, NULL, hWin2, addr srect, 2
        pop eax                 ; bottom of bottomost control
        sub eax,srect.bottom    ; bottom of next higher control
        mov LineSize,eax

        inv SetScrollInfo,hWin2,SB_VERT,addr vs,TRUE
        inv ShowScrollBar,hWin2,SB_VERT,TRUE
        mov eax,vs.nMin ; mov window to correct initial position
        neg eax
        inv ScrollWindow,hWin2,0,eax,NULL,NULL ; syncronize window to scrollbar
    .endif

    xor eax,eax
    ret
DlgProc2    endp

MakeHeaders proc
    inv CreateWindowEx,0,soff("STATIC"),soff("I"),
            WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS,
            Left1,Top,300,HDel,hWin,1001,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

    inv CreateWindowEx,0,soff("BUTTON"),soff("Run All Tests"),
            WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_MULTILINE or BS_VCENTER or BS_CENTER,
            Left5+Wide5-90,Top,90,HDel,hWin,1101,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

    add Top,HDel+2

    inv CreateWindowEx,0,soff("STATIC"),soff("Description of test"),
            WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_CENTER,
            Left2,Top,Wide2,HDel,hWin,1002,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

    inv CreateWindowEx,0,soff("STATIC"),soff(" "),
            WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_CENTER,
            Left3,Top,Wide3,HDel,hWin,1003,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

    inv CreateWindowEx,0,soff("STATIC"),soff("Clock Cycles"),
            WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_CENTER,
            Left4,Top,Wide4,HDel,hWin,1004,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
    
    inv CreateWindowEx,0,soff("STATIC"),soff(" "),
            WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_CENTER,
            Left5,Top,Wide5,HDel,hWin,1005,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
   
    add Top,HDel
    ret
MakeHeaders endp

MakeControls proc 
    mov eax,2000        ; each starts with id 2000+TestNum
    add eax,TestNum
    mov LastControl,eax ; save location of last control for dialog resizer code
    mov CtlGp,eax
    inv CreateWindowEx,0,soff("BUTTON"),abuff,
            WS_CHILD or WS_VISIBLE or WS_TABSTOP,
            Left1,Top,Wide1,TDel,hWin2,CtlGp,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
    add CtlGp,1000
    
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,aBlank,
            WS_VISIBLE or WS_CHILDWINDOW or ES_NOHIDESEL or ES_MULTILINE,
            Left2,Top,Wide2,TDel,hWin2,CtlGp,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
    add CtlGp,1000
    
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,aBlank,
            WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
            Left3,Top,Wide3,TDel,hWin2,CtlGp,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
    add CtlGp,1000
    
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,aBlank,
            WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
            Left4,Top,Wide4,TDel,hWin2,CtlGp,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
    add CtlGp,1000
    
    inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,aBlank,
            WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
            Left5,Top,Wide5,TDel,hWin2,CtlGp,hInst,0
    inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

    mov eax,TDel    ; set up for next group
    add Top,eax

    ret
MakeControls EndP

SetDesc proc    ; enter with Description Offset in ebx
    pusha       ; save users setup if any
    push ebx    
    mov eax,TestNum
    add eax,3000        ; get the id of the description box
    invoke GetDlgItem,hWin2,eax
    mov htemp,eax         ; save handle to control
    pop ebx     ; get back Description offset
    invoke SendMessage,htemp,WM_SETTEXT,0,ebx
    popa
    ret
SetDesc EndP
.data?
hf   dd ?  ; handle for result file
.data
.code

DoSetup:
    pusha   ; save everything while we add controls, etc.
    lea ebx,[CallTable+eax*4-4]
    mov [ebx],edx
    mov TestNum,eax
    printx abuff,"Test",dd TestNum  ; get button caption
    call MakeControls
    mov eax,[ebx]           
    call eax        ; call for first time just to get description
    popa
    ret


PrintToFile:
    pusha
    inv _lcreat,soff("Results.txt"),0
    mov hf,eax
    inv _lwrite,hf,addr headers,headersize
    push TestNum
    mov TestNum,1
    mov ebx,offset CallTable
    .repeat
        .if dword ptr [ebx]   ; was there an address set up?
            mov esi,TestNum
            call DoPrint
        .endif
        add ebx,4
        add TestNum,1
    .until TestNum>MaxTests
    pop TestNum

    inv CloseHandle,hf
    popa
    ret   

DoPrint:
    mov edi,abuff
    mov al,' '
    mov ecx,99
    rep stosb
    add esi,2000        ; each starts with id 2000+TestNum
    mov edi,abuff
    inv GetDlgItemText,hWin2,esi,edi,100 ; get button caption
    mov [edi+eax],byte ptr ' '  ; remove zero byte terminator
    add edi,8
    add esi,3000
    inv GetDlgItemText,hWin2,esi,edi,100 ; get clock ticks
    mov [edi+eax],byte ptr ' '  ; remove zero byte terminator
    .if dword ptr [edi]=='    '
        ret
    .endif
    add edi,9
    sub esi,2000        ; get desc
    inv GetDlgItemText,hWin2,esi,edi,100
    add edi,eax
    mov [edi],word ptr 0a0dh
    add edi,2
    sub edi,abuff                        
    inv _lwrite,hf,abuff,edi
    ret

SetupCallTable macro
CallTableSetup:  ; call table setup, save offsets of tests, and also add controls to dialog
    Repeat MaxTests
        testnum=testnum+1
        arg CatStr <Test>, %testnum ;; construct  Test1, Test2, etc.
        if (opattr(arg)) and 01y    ;; if it is a label
            mov eax,testnum
            mov edx,offset arg
            call DoSetup
        endif
    endm    
    ret
end Program
endm


Program:
    invoke  InitCommonControls
    invoke  GetModuleHandle, 0
    mov hInst,eax
    mov edx,offset DlgProc
    invoke  DialogBoxParam, eax, 101, 0, edx, 0
    invoke  ExitProcess, eax
