TimesToLoop = 100;0;0;00;0 ; number of times to loop
PrintResults equ 1   ; Print to result file if non-zero
DoMin=1 ; time each loop, pick minimum timing
DoAvg=2 ; run all loops continuously and average
DoSep=3 ; time each loop, average results
DoMode=4 ; which value occurs most often
tsttype=3; DoMin/DoAvg/DoSep
saveplot=01    ; prints out plot.txt file containing time for each trial.  DoMin and DoSep only
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging
DoLocal=1
TopLine = 120  ;; need extra space for graphics test

include Part1.inc ;F:\WinAsm\Progs\AllTimingTests\1BaseRoutines\Part1.inc

DoFlush = 0;1 ;; do gdi flush after each test


; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in TestX to a number (Test1, Test2,...Test99)
TestX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ;Showit LongInt ; result value to show in rightmost box on each line
    ret

;--------------------------------- Test Procs/data -------------------------------------------

;  Place any test procs or setup/checking procs you wish here

.data?
;hWin  dd ?   ; dialog handle
;hInst dd ?
hdc    dd ?   ; temp dc of dialog
mdc    dd ?   ; memory dc of hidden buffer

hfont  dd ?
hpen   dd ?
hbrush dd ?
lb LOGBRUSH <?>

mbmp  dd ?  ; bmp for memory dc

hHeap dd ?  ; handle to heap
.data
align 4
mbuff dd 0  ; start of scratch buffer in heap
mwidth  = 500   ; test graphic size
mheight = 100  
deffont LOGFONT  <-8, 0,0,0,0,0,0,0,DEFAULT_CHARSET,0,0,0,FIXED_PITCH,"Small Fonts">

.data?
align 4
alignflag dd ?

lpp POINT <?>
lrr RECT <?>
hbrush2 dd ?
xref dd ?
.data
sText db "This is a test string testing, 1, 2, 3..This is a test string testing, 1, 2, 3..This is a test string testing, 1, 2, 3",0
SLen dd $-sText-1
left = 0
top=0
right=mwidth
bottom=mheight
rr RECT <left,top,right,bottom>

TextAlignment dd DT_LEFT    

.code
Setup1 proc
    .if mbuff==0 
        inv GetProcessHeap
        mov hHeap,eax
        inv HeapAlloc,hHeap,HEAP_ZERO_MEMORY,2048
        mov mbuff,eax
        inv CreateFontIndirect,addr deffont  ; 10 pt small
        mov hfont,eax
    .endif
    .if mdc
        inv DeleteDC,mdc
        inv DeleteObject,mbmp
    .endif
    ;inv GetClientRect,hWin,addr crect    ; get the size needed for the bitmap
    inv GetDC,hWin  ; get dc's
    mov hdc,eax
    inv CreateCompatibleDC,hdc      ; create dc for hidden buffer
    mov mdc,eax
    inv SelectObject,mdc,hfont
    inv SetBkMode,mdc,TRANSPARENT
    inv CreateCompatibleBitmap,hdc, mwidth, mheight ; make a hidden buffer of the appropriate size
    mov mbmp,eax
    inv SelectObject, mdc, mbmp
	ret
Setup1 endp
Wrapup1 proc
    .if mdc
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
        inv DeleteDC,mdc
        inv DeleteObject,mbmp
        inv ReleaseDC,hWin,hdc
    .endif
    call delbrush    
	ret
Wrapup1 endp
.data
bih BITMAPINFOHEADER <sizeof BITMAPINFOHEADER, \
  mwidth,   \;biWidth
  -mheight, \;biHeight
  1,        \;biPlanes WORD
  32,       \;biBitCount WORD
  BI_RGB,   \;biCompression
  0,        \;biSizeImage
  0,        \;biXPelsPerMeter
  0,        \;biYPelsPerMeter
  0,        \;biClrUsed
  0 >       ;biClrImportant
mbits dd 0  
.code
Setup2 proc
    .if mbuff==0 
        inv GetProcessHeap
        mov hHeap,eax
        inv HeapAlloc,hHeap,HEAP_ZERO_MEMORY,2048
        mov mbuff,eax
        inv CreateFontIndirect,addr deffont  ; 10 pt small
        mov hfont,eax
    .endif
    .if mdc
        inv DeleteDC,mdc
        inv DeleteObject,mbmp
    .endif
    inv GetDC,hWin  ; get dc's
    mov hdc,eax
    inv CreateCompatibleDC,hdc      ; create dc for hidden buffer
    mov mdc,eax
    inv CreateDIBSection,hdc,addr bih,DIB_RGB_COLORS,addr mbits,0,0
    mov mbmp,eax
    inv SelectObject,mdc,eax
    inv SelectObject,mdc,hfont
    inv SetBkMode,mdc,TRANSPARENT

	ret
Setup2 endp
Wrapup2 proc
    .if mdc
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
        inv DeleteDC,mdc
        inv DeleteObject,mbmp
        inv ReleaseDC,hWin,hdc
    .endif
    call delbrush    
	ret
Wrapup2 endp

makbrush proc color
    inv CreateSolidBrush,color
    mov hbrush,eax
    ret
makbrush EndP
delbrush proc
    .if hbrush
        invoke DeleteObject,hbrush
        mov hbrush,0
    .endif
    ret
delbrush EndP


;---------------------------- Routines Being Timed --------------------------------------  

Test1:
    Desc 'draw with pen'
    call Setup1
    invoke CreatePen,PS_SOLID,1,Red
    mov hpen,eax
    inv SelectObject,mdc, hpen  ;Associate pen with object
    inv GdiFlush
    BeginCounter
        inv MoveToEx,mdc, 0, 42,addr lpp
        inv LineTo,mdc,right,42
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    invoke DeleteObject,hpen
    ret
   
Test2:
    Desc 'draw with pen on DIB'
    call Setup2
    invoke CreatePen,PS_SOLID,1,Green
    mov hpen,eax
    inv SelectObject,mdc, hpen  ;Associate pen with object
    inv GdiFlush
    BeginCounter
        inv MoveToEx,mdc, 0, 42,addr lpp
        inv LineTo,mdc,right,42
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    invoke DeleteObject,hpen
    ret
   
Test11:
    Desc 'fill background using FillRect with brush'
    call Setup1
    inv makbrush,Red
    inv GdiFlush
    BeginCounter
        inv FillRect,mdc,addr rr,hbrush
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret

Test12:
    Desc 'fill background using PatBlt with brush'
    call Setup1
    inv makbrush,Magenta
    inv SelectObject,mdc,hbrush
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,0,0,mwidth,mheight,PATCOPY
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret
      
Test13:
    Desc 'fill background using FillRect with brush on DIB'
    call Setup2
    inv makbrush,Green
    inv GdiFlush
    BeginCounter
        inv FillRect,mdc,addr rr,hbrush
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
   
Test14:
    Desc 'fill background using direct access on DIB'
    call Setup2
    inv GdiFlush
    BeginCounter
        mov edi,mbits
        mov ecx,mwidth*mheight
        mov eax,Blue
        rep stosd
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret

Test15:
    Desc 'fill background using PatBlt with brush on DIB'
    call Setup2
    inv makbrush,Yellow
    inv SelectObject,mdc,eax
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,0,0,mwidth,mheight,PATCOPY
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
      
Test21:
    Desc 'line using FillRect and Brush'
    call Setup1
    inv makbrush,Red
    inv GdiFlush
    BeginCounter
        mov lrr.RECT.left,left
        mov lrr.RECT.top,top+15
        mov lrr.RECT.right,right
        mov lrr.RECT.bottom,top+16
        inv FillRect,mdc,addr lrr,hbrush
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret
Test22:
    Desc 'line using PatBlt and Brush'
    call Setup1
    inv makbrush,Magenta
    inv SelectObject,mdc,hbrush
    inv GdiFlush
    BeginCounter
       inv PatBlt,mdc,left,top+15,right-left,1,PATCOPY
       if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret
Test23:
    Desc 'line using FillRect and Brush on DIB'
    call Setup2
    inv makbrush,Green
    inv GdiFlush
    BeginCounter
        mov lrr.RECT.left,left
        mov lrr.RECT.top,top+15
        mov lrr.RECT.right,right
        mov lrr.RECT.bottom,top+16
        inv FillRect,mdc,addr lrr,hbrush
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
Test24:
    Desc 'line using PatBlt and Brush on DIB'
    call Setup2
    inv makbrush,Yellow
    inv SelectObject,mdc,hbrush
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,left,top+15,right-left,1,PATCOPY
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
Test31:
    Desc 'line using setpixel'
    call Setup1
    inv GdiFlush
    BeginCounter
        mov esi,left
        mov edi,top
        add edi,5
        .repeat
            inv SetPixel,mdc,esi,edi,Red
            inc esi
        .until esi==right
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret

Test32:
    Desc 'line using setpixel on DIB'
    call Setup2
    inv GdiFlush
    BeginCounter
        mov esi,left
        mov edi,top
        add edi,5
        .repeat
            inv SetPixel,mdc,esi,edi,Green
            inc esi
        .until esi==right
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
Test33:
    Desc 'line using direct access to bitmap on DIB'
    call Setup2
    inv PatBlt,mdc,0,0,mwidth,mheight,WHITENESS
    inv GdiFlush
    BeginCounter
        mov esi,left
        mov edi,mbits
        add edi,5*mwidth*4
        mov eax,Black
        .repeat
            stosd
            inc esi
        .until esi==right
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret
Test34:
    Desc 'line using PatBlt one pixel at a time in place of setpixel'
    call Setup1
    inv makbrush,Yellow
    inv SelectObject,mdc,hbrush
    inv GdiFlush
    BeginCounter
        mov esi,left
        mov edi,top
        add edi,5
        .repeat
            inv PatBlt,mdc,esi,edi,1,1,PATCOPY
            inc esi
        .until esi==right
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret
Test41:
    Desc 'bitblt from normal memory dc to dialog dc'
    call Setup1
    inv makbrush,Red
    mov lrr.RECT.left,left
    mov lrr.RECT.top,top+15
    mov lrr.RECT.right,right
    mov lrr.RECT.bottom,top+16
    inv FillRect,mdc,addr lrr,hbrush
    inv GdiFlush
    BeginCounter
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup1
    ret
Test42:
    Desc 'bitblt from DIB dc to dialog dc'
    call Setup2
    inv makbrush,Green
    mov lrr.RECT.left,left
    mov lrr.RECT.top,top+15
    mov lrr.RECT.right,right
    mov lrr.RECT.bottom,top+16
    inv FillRect,mdc,addr lrr,hbrush
    inv GdiFlush
    BeginCounter
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    call Wrapup2
    ret

Test51:
    Desc 'DrawText'
    inv Setup1
    inv makbrush,White
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Cyan
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv DrawText, mdc, addr sText, -1, addr rr, DT_LEFT
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup1
    ret

Test52:
    Desc 'DrawText on DIB'
    inv Setup2
    inv makbrush,White
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Cyan
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv DrawText, mdc, addr sText, -1, addr rr, DT_LEFT
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup2
    ret

Test54:
    Desc 'simple ExtTextOut'
    inv Setup1
    inv makbrush,White
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Red
    inv SetTextAlign,mdc,DT_LEFT
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv ExtTextOut, mdc,xref ,rr.top ,ETO_CLIPPED,addr rr,addr sText, SLen,0
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup1
    ret

Test55:
    Desc 'simple ExtTextOut on DIB'
    inv Setup2
    inv makbrush,White
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Red
    inv SetTextAlign,mdc,DT_LEFT
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv ExtTextOut, mdc,xref ,rr.top ,ETO_CLIPPED,addr rr,addr sText, SLen,0
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup2
    ret

Test57:
    Desc 'simple TextOut'
    inv Setup1
    inv makbrush,White
    inv SetBkMode,mdc,TRANSPARENT  ;OPAQUE
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Green
    inv SetBkColor,mdc,Red
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv TextOut, mdc,xref ,rr.top ,addr sText, SLen
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup1
    ret

Test58:
    Desc 'simple TextOut on DIB'
    inv Setup2
    inv makbrush,White
    inv SetBkMode,mdc,TRANSPARENT  ;OPAQUE
    inv FillRect,mdc,addr rr,hbrush
    inv SetTextColor,mdc,Green
    inv SetBkColor,mdc,Red
    m2m xref,rr.left
    inv GdiFlush
    BeginCounter
        inv TextOut, mdc,xref ,rr.top ,addr sText, SLen
        if DoFlush
            inv GdiFlush
        endif
    EndCounter
    inv Wrapup2
    ret

Test60:
    Desc 'Full plot'
    inv Setup1
    inv CreateSolidBrush,White
    inv GetStockObject,BLACK_BRUSH
    inv SelectObject,mdc,eax
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,0,0,mwidth,mheight,WHITENESS
        mov esi,10
        .repeat
            inv PatBlt,mdc,10,esi,mwidth - 20,1,BLACKNESS
            add esi,10
        .until esi>mheight-10
         mov esi,10
        .repeat
            inv PatBlt,mdc,esi,10,1,mheight - 19,BLACKNESS
            add esi,10
        .until esi>mwidth-10
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
      
        inv GdiFlush
    EndCounter
    inv Wrapup1
    ret

Test61:
    Desc 'Full plot on DIB using patblt for grid'
    inv Setup2
    inv CreateSolidBrush,White
    inv GetStockObject,BLACK_BRUSH
    inv SelectObject,mdc,eax
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,0,0,mwidth,mheight,WHITENESS
        mov esi,10
        .repeat
            inv PatBlt,mdc,10,esi,mwidth - 20,1,PATCOPY
            add esi,10
        .until esi>mheight-10
         mov esi,10
        .repeat
            inv PatBlt,mdc,esi,10,1,mheight - 19,PATCOPY
            add esi,10
        .until esi>mwidth-10
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
       
        inv GdiFlush
    EndCounter
    inv Wrapup2
    ret

Test62:
    Desc 'Full plot on DIB using direct access for grid'
    inv Setup2
    inv CreateSolidBrush,White
    inv GetStockObject,BLACK_BRUSH
    inv SelectObject,mdc,eax
    inv GdiFlush
    BeginCounter
        inv PatBlt,mdc,0,0,mwidth,mheight,WHITENESS
        mov ebx,mbits
        add ebx,10*mwidth*4
        mov edi,mheight-20
        .repeat
            mov esi,10*4
            .repeat
                mov dword ptr [ebx+esi],Black
                add esi,4
            .until esi > 4 * mwidth - 40
            add ebx,mwidth*4*10
            sub edi,10
        .until sdword ptr edi < 0
                
        mov ebx,mbits
        add ebx,10*mwidth*4+40
        mov edi,(mwidth-20)/10+1
        .repeat
            mov esi,mheight-20
            push ebx
            .repeat
                mov dword ptr [ebx],Black
                add ebx,4*mwidth
                dec esi
            .until zero?
            pop ebx
            add ebx,4*10
            dec edi
        .until zero?
        inv BitBlt,hdc,10,10,500,100,mdc,0,0,SRCCOPY
       
        inv GdiFlush
    EndCounter
    inv Wrapup2
    ret

  ;           ------------------------ end of timing tests --------------------
SetupCallTable
  